package cn.iocoder.yudao.module.smartfactory.service.size;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.smartfactory.controller.admin.size.vo.SizePageReqVO;
import cn.iocoder.yudao.module.smartfactory.controller.admin.size.vo.SizeSaveReqVO;
import cn.iocoder.yudao.module.smartfactory.dal.dataobject.size.SizeDO;

import javax.validation.Valid;
import java.util.Collection;
import java.util.List;

/**
 * 规格 Service 接口
 *
 * @author 符溶馨
 */
public interface SizeService {

    /**
     * 创建规格
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createSize(@Valid SizeSaveReqVO createReqVO);

    /**
     * 更新规格
     *
     * @param updateReqVO 更新信息
     */
    void updateSize(@Valid SizeSaveReqVO updateReqVO);

    /**
     * 删除规格
     *
     * @param id 编号
     */
    void deleteSize(Long id);

    /**
     * 获得规格
     *
     * @param id 编号
     * @return 规格
     */
    SizeDO getSize(Long id);

    /**
     * 获得规格
     *
     * @param ids 编号
     * @return 规格
     */
    List<SizeDO> getSizes(Collection<Long> ids);

    /**
     * 获得规格分页
     *
     * @param pageReqVO 分页查询
     * @return 规格分页
     */
    PageResult<SizeDO> getSizePage(SizePageReqVO pageReqVO);

    /**
     * 获得规格列表
     * @return 规格列表
     */
    List<SizeDO> getListSize();
}